/*
PolyGun

Copyright (c) 2023 kacperks https://kacperks.cubesoftware.xyz

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

#ifndef POLYGUN_RENDERER_VERTEX_ARRAY_HPP
#define POLYGUN_RENDERER_VERTEX_ARRAY_HPP

#include "../core.hpp"
#include "vertex.hpp"

namespace polygun::renderer {
	class VertexArray {
	public:
		VertexArray(): m_vao(0), m_ebo(0), m_vbo(0), m_num_of_indices(0),
			m_num_of_vertices(0) {}

		VertexArray(Vertex* vertices, GLsizei v_size, GLuint* indices = nullptr, GLsizei i_size = 0): 
			m_num_of_indices(i_size), m_num_of_vertices(v_size) {
			glGenVertexArrays(1, &m_vao);
			glGenBuffers(1, &m_vbo);
			glGenBuffers(1, &m_ebo);

			glBindVertexArray(m_vao);
			glBindBuffer(GL_ARRAY_BUFFER, m_vbo);
			glBufferData(GL_ARRAY_BUFFER, m_num_of_vertices * sizeof(Vertex), vertices, GL_STATIC_DRAW);

			glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, m_ebo);
			glBufferData(GL_ELEMENT_ARRAY_BUFFER, m_num_of_indices * sizeof(GLuint), indices, GL_STATIC_DRAW);

			// Positions
			glEnableVertexAttribArray(0);
			glVertexAttribPointer(0, 3, GL_FLOAT, GL_FALSE, sizeof(Vertex), (GLvoid*)0);
			// Normals
			glEnableVertexAttribArray(1);
			glVertexAttribPointer(1, 3, GL_FLOAT, GL_FALSE, sizeof(Vertex), (GLvoid*)offsetof(Vertex, m_normal));
			// Texcoords
			glEnableVertexAttribArray(2);
			glVertexAttribPointer(2, 2, GL_FLOAT, GL_FALSE, sizeof(Vertex), (GLvoid*)offsetof(Vertex, m_tex_coords));

			glBindVertexArray(0);
			m_num_of_vertices /= sizeof(Vertex);
		}
		
		~VertexArray() {
			glDeleteVertexArrays(1, &m_vao);
			glDeleteBuffers(1, &m_vbo);
			glDeleteBuffers(1, &m_ebo);
		}

		void push_attrib(GLuint index, GLint size, GLsizei stride, GLvoid* ptr) {
			glEnableVertexAttribArray(index);
			glVertexAttribPointer(index, size, GL_FLOAT, GL_FALSE, size, ptr);
		}

		void bind() {
			glBindVertexArray(m_vao);
		}

		void unbind() {
			glBindVertexArray(0);
		}

		void draw_elements(GLenum mode = GL_TRIANGLE_STRIP) {
			glBindVertexArray(m_vao);
			glDrawElements(mode, m_num_of_indices, GL_UNSIGNED_INT, 0);
			glBindVertexArray(0);
		}

		void draw_arrays(GLenum mode = GL_TRIANGLES) {
			glBindVertexArray(m_vao);
			glDrawArrays(mode, 0, m_num_of_vertices);
			glBindVertexArray(0);
		}

	private:
		GLuint m_vao, m_vbo, m_ebo;
		GLsizei m_num_of_indices, m_num_of_vertices;
	};
}

#endif // POLYGUN_RENDERER_VERTEX_ARRAY_HPP
